program ExFormat;

{$APPTYPE CONSOLE}
uses
  SysUtils,
  Windows,
  TokenID in '..\ExCommon\TokenID.pas',
  GlobalDef in '..\ExCommon\GlobalDef.pas',
  rijndael in '..\TeleToken\rijndael.pas',
  TeleToken in '..\TeleToken\TeleToken.pas',
  ZeroMem in '..\ExCommon\ZeroMem.pas';

var
  n : byte;
{$I '..\ExCommon\MainDef.pas'}
begin

  Time:=GetTickCount();

  ZeroMemory(PassTbl,16*PASS_NO);

  // sprawdzenie wersji biblioteki
  WriteLn('');
  WriteLn('Odczyt wersji biblioteki');
  TVTT_GetVersion(Ver,SubVer,APIVer);
  WriteLn('Wersja pliku:' + #9 + #9 + #9 + IntToStr(Ver) + '.' + IntToStr(SubVer));
  WriteLn('Wersja API:' + #9 + #9 + #9 + IntToStr(APIVer));

  // otwarcie dostepu do tokenu
  Write('Otwarcie dostepu do Tokenu:');
  TokenInfoTblSize:=TVTTTI_TABLE_SIZE;  // wpisanie rozmiaru tablicy
  Status:=TVTT_FindToken(@TokenH,10,TOKEN_ID,0,0,@TokenInfoTblSize,@TokenInfoTbl);
  if (Status<>0) then
    writeln(#9 + IntToHex((Status shr 8), 2) + ':' + IntToHex((Status and $FF), 2))
  else
    writeln(#9 + 'OK');

  n:=0;
  while (n<TokenInfoTblSize) do
  begin
    if (TokenInfoOffsetTbl[n]=TVTTTI_ID) then
    WriteLn(#9 + #9 + #9 + #9 + TokenInfoTextTbl[n] +
        IntToHex(TokenInfoTbl[TokenInfoOffsetTbl[n]],8))
    else
      WriteLn(#9 + #9 + #9 + #9 + TokenInfoTextTbl[n] +
          IntToStr(TokenInfoTbl[TokenInfoOffsetTbl[n]]));
    inc(n);
  end;
  // odczytanie nr. seryjnego TeleTokenu
  Write('Odczyt nr. ser. TeleTokenu:');
  Status:=TVTT_GetSerialNr(TokenH, 10, @SerialNr);
  if (Status<>0) then
    WriteLn(#9 + #9 + IntToHex(Status shr 8, 2) + ':' + IntToHex(Status and $ff, 2))
  else
    WriteLn(#9 + 'OK');

  WriteLn('Numer seryjny:' + #9 + #9 + #9 + IntToHex(SerialNr[0],2) + IntToHex(SerialNr[1],2) + IntToHex(SerialNr[2],2) + IntToHex(SerialNr[3],2));

  // rozpoczecie sesji
  Write('Rozpoczecie sesji:');
  Status:=TVTT_StartSession(TokenH,1);
  if (Status<>0) then
    WriteLn(#9 + #9 + IntToHex(Status shr 8, 2) + ':' + IntToHex(Status and $FF, 2))
  else
    WriteLn(#9 + #9 + 'OK');

  // format Tokenu
  Write('FormatTokenu:');
  ZeroMemory(OutDataA,16);
  ZeroMemory(OutDataB,16);
  ZeroMemory(InDataA,16);
  ZeroMemory(InDataB,16);
  OutKey:=0;                              // znacznik wiadomosci nie szyfrowanej
  OutDataB[TVTTD_CMD]:=TVTTC_FORMAT;      // rozkaz formatowania Tokenu
  OutDataB[TVTTD_PARAM1]:=1;              // najmodszy bajt ID odbiorcy Tokenu


  //haso formatowania
  OutDataA[4]:=TOKEN_FORMAT_PASS and $FF;
  OutDataA[3]:=(TOKEN_FORMAT_PASS shr 8) and $FF;
  OutDataA[2]:=(TOKEN_FORMAT_PASS shr 16) and $FF;
  OutDataA[1]:=(TOKEN_FORMAT_PASS shr 24) and $FF;
  OutDataA[0]:=(TOKEN_FORMAT_PASS shr 32) and $FF;
  //numer seryjny
	OutDataA[5]:=5;
	OutDataA[6]:=6;
	OutDataA[7]:=7;
	OutDataA[8]:=8;

  TVTT_CalcAuth(OutDataA,OutDataB);       // policzenie bloku kontrolnego
  Status:=TVTT_Talk(TokenH,200,OutKey,@OutDataA,@OutDataB,@InKey,@InDataA,@InDataB);
  if (Status=$600) then
    WriteLn(#9 + #9 + #9 + 'Restart Tokenu...')
  else
    WriteLn(#9 + #9 + #9 + IntToHex((Status shr 8), 2) + ':'  + IntToHex(Status and $FF,2));

  // zakonczenie sesji
  Write('Zamkniecie sesji:');
  Status:=TVTT_EndSession(TokenH);
  if (Status<>0) then
    WriteLn(#9 + #9 + IntToHex((Status shr 8), 2) + ':'  + IntToHex(Status and $FF,2))
  else
    WriteLn(#9 + #9 + 'OK');

  // zamknicie dostpu do Tokenu
  Write('Zamkniecie dostepu do Tokenu:');
  Status:=TVTT_FreeToken(TokenH);
  if (Status<>0) then
    WriteLn(#9 + IntToHex((Status shr 8), 2) + ':'  + IntToHex(Status and $FF,2))
  else
    WriteLn(#9 + 'OK');

  Time:=GetTickCount()-Time;
  WriteLn('Time: ' + IntToStr(round(Time/1000)) + '.' + IntToStr(round(Time/10) mod 100));
end.
