unit Root;

interface

uses
  Windows, Forms, SysUtils, StdCtrls, Classes, Controls,
  TokenID, GlobalDef, rijndael, TeleToken, ZeroMem, Dialogs, Printers;

type
  TfrmRoot = class(TForm)
    ListBox: TListBox;
    btLosuj: TButton;
    procedure Losuj();
    procedure btLosujClick(Sender: TObject);
    procedure ListBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmRoot     : TfrmRoot;
  KeyPressed  : char;

implementation

{$R *.dfm}

//------------------------------------------------------------------------------
procedure TfrmRoot.Losuj();
const
  RandInitFileName  = 'MyRandInitFile.bin';
var
  hRandInitFile : THandle;
  RandInitTbl   : array [0..TVTT_RAND_INIT_TBL_SIZE] of byte;
  n             : cardinal;
  tmp           : integer;
  sTextLine     : string;
  Time,TTime    : cardinal;
  RandTbl       : array [0..15] of byte ;
begin
  // przygotowanie tablicy inicjujcej wypenionej moliwie nieprzewidywalnymi wartociami
  //	- metoda przykadowa prosta ale nie zalecana, naley zastosowa wasn metod
  n:=0;
  while(n<TVTT_RAND_INIT_TBL_SIZE) do
    begin
      RandInitTbl[n]:=byte(GetTickCount());
      inc(n);
    end;

  // odczytanie pliku inicjujcego (o ile istnieje)
  hRandInitFile:=CreateFile(RandInitFileName,GENERIC_READ,0,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
  if (hRandInitFile<>INVALID_HANDLE_VALUE) then
    begin
      ReadFile(hRandInitFile,RandInitTbl,TVTT_RAND_INIT_TBL_SIZE,n,nil);
      // UWAGA! Nie nastpuje powodzenie poprawnoci odczytu poniewa jeli odczyt si nie uda to tablica
      //	jest ju wypeniona wartociami moliwie nieprzewidywalnymi
      //	- jest to metoda prosta ale nie zalecana, w rozwizaniu zalecanym powinno by zaimplementowane:
      //		* sprawdzenie poprawnoci odczytu
      //		* szyfrowanie pliku z tablic inicjalizujc
      //		* sprawdzenie oryginalnoci pliku (suma kontrolna, podpis cyfrowy, etc.)
      CloseHandle(hRandInitFile);
    end;

  // zainicjowanie Generatora liczb pseudolosowych
  TVTT_RandInit(RandInitTbl);

  // zapisanie nowej tablicy inicjujcej generator
  TVTT_RandGetInit(RandInitTbl);
  hRandInitFile:=CreateFile(RandInitFileName,GENERIC_WRITE,0,nil,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
  if (hRandInitFile<>INVALID_HANDLE_VALUE) then
    begin
      WriteFile(hRandInitFile,RandInitTbl,TVTT_RAND_INIT_TBL_SIZE,n,nil);
      // UWAGA! nie nastpuje przeprowadzenie poprawnoci zapisu
      //	- naley zastosowa wasn obsug bdu zapisu zalen od potrzeb
      CloseHandle(hRandInitFile);
    end;

  // powysze kroki konieczne eby program przy nastpnym uruchomieniu
  // wystartowa z innym stanem generatora liczb losowych
  //	- wykonywane na wypadek zakoczenia programu bez zapisu ostatniego stanu generatora

  // zbieranie wartoci losowych
  //	ta operacja powinna by wykonywana w gwnej ptli obsugi wiadomoci
  //	zdarzeniami mog by np.:
  //	* moment wcinicia klawisza na klawiaturze (np. odczytany przez GetTickCount())
  //	* kod wcinitego klawisza
  //	* moment wcinicia przycisku myszki (np. odczytany przez GetTickCount())
  //	* moment wcinicia poruszenia myszki (np. odczytany przez GetTickCount())
  //	* kierunek przesunicia myszki
  //	* inne mniej lub bardziej nieprzewidywalne zdarzenia wystepujce w systemie
  // ponisza procedura moe by przydatna przy pierwszym uruchomieniu programu gdy
  //	nie ma jeszcze tablicy inicjujcej generator liczb pseudolosowych

  ListBox.AddItem('Generowanie liczb pseudolosowych:', nil);
  Time:=GetTickCount() + 1000;
  TTime:=GetTickCount() + 10000;
  n:=0;
  while (GetTickCount()<TTime) do
    begin
      inc(n);
      if (KeyPressed<>#0) then 	                        // oczekiwanie na wcinicie klawisza
        begin
          TVTT_Randomize(0,GetTickCount());	          // jako pierwsze rdo przyjto moment wcinicia klawisza
          TVTT_Randomize(1,cardinal(KeyPressed));	    // jako drugie rdo przyjto kod wcinitego klawisza
          TVTT_Randomize(2,n);				                  // jako trzecie rdo przyjto moment wcinicia klawisza wyraony w iloci obrotw ptli
          KeyPressed:=#0;
        end
      else
        Sleep(100);							                        // zwrcenie czci czasu do systemu

      if (GetTickCount()>Time) then			                // "co jaki czas" wygenerowanie i wywietlenie wartoci pseudolosowej
        begin
          Time:=GetTickCount()+1000;
          TVTT_Rand(RandTbl);
          sTextLine:='';
          for tmp:=0 to 15 do
            sTextLine:=sTextLine + IntToHex(RandTbl[tmp],2) + ' ';
          ListBox.AddItem(sTextLine, nil);
          Application.ProcessMessages;
        end;
    end;

  ListBox.AddItem(' ', nil);

  // zapisanie stanu generatora liczb pseudolosowych
  TVTT_RandGetInit(RandInitTbl);
  hRandInitFile:=CreateFile(RandInitFileName,GENERIC_WRITE,0,nil,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
  if (hRandInitFile<>INVALID_HANDLE_VALUE) then
    begin
      WriteFile(hRandInitFile,RandInitTbl,TVTT_RAND_INIT_TBL_SIZE,n,nil);
      // UWAGA! nie nastpuje przeprowadzenie poprawnoci zapisu
      //	- naley zastosowa wasn obsug bdu zapisu zalen od potrzeb
      CloseHandle(hRandInitFile);
    end;
end;
//------------------------------------------------------------------------------
procedure TfrmRoot.btLosujClick(Sender: TObject);
begin
  ListBox.SetFocus;
  Losuj;
end;
//------------------------------------------------------------------------------
procedure TfrmRoot.ListBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  KeyPressed := Chr(Key);
end;
//------------------------------------------------------------------------------
initialization
  KeyPressed:=#0;
end.
